Index: /trunk/kernel/kern/socket.h
===================================================================
--- /trunk/kernel/kern/socket.h	(revision 657)
+++ /trunk/kernel/kern/socket.h	(revision 657)
@@ -0,0 +1,217 @@
+/*
+ * socket.h - socket descriptor and API definition.
+ * 
+ * Authors  Alain Greiner    (2016,2017,2018,2019,2020)
+ *
+ * Copyright (c) UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-MKH
+ *
+ * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef _SOCKET_H_
+#define _SOCKET_H_
+
+#include <kernel_config.h>
+#include <hal_kernel_types.h>
+#include <xlist.h>
+#include <remote_buf.h>
+#include <remote_busylock.h>
+
+/****************************************************************************************
+ * This defines the three commands that can be requested by a client thread to
+ * a TX server thread. These commands are registered in the socket descriptor.
+ ****************************************************************************************/
+
+typedef enum sock_cmd_e
+{
+    SOCKET_TX_CONNECT = 20,   /*! request 3 steps handshake (TCP socket only)           */
+    SOCKET_TX_SEND    = 21,   /*! request to send data      (TCP or UDP socket)         */
+    SOCKET_TX_CLOSE   = 22,   /*! request 3 steps handshake (TCP socket only)           */
+}
+sock_cmd_t;
+
+/***************************************************************************************** 
+ * This structure defines a socket descriptor. In order to parallelize the transfers,
+ * the set of all registered sockets is split in several subsets.
+ * The number of subsets is the number of  NIC channels. 
+ * The distribution key is computed from the (remote_addr/remote_port) couple.
+ * This computation is done by the NIC hardware for RX packets, 
+ * and by the dev_nic_connect() function for the TX packets.
+ *
+ * A socket is attached to the NIC_TX[channel] & NIC_RX[channel] chdevs.
+ * Each socket descriptor allows the TX and TX server threads to access various buffers:
+ * - the user "send" buffer contains the data to be send by the TX server thread.
+ * - the kernel "receive" buffer contains the data received by the RX server thread.
+ * - the kernel "r2t" buffer allows the RX server thread to make direct requests
+ *   to the associated TX server (to implement the TCP 3 steps handshake).
+ *
+ * The synchronisation mechanism between the clients threads and the servers threads
+ * is different for TX and RX transfers:
+ *
+ * 1) For a TX transfer, it can exist only one client thread for a given socket,
+ *    the transfer is always initiated by the local process, and all TX commands
+ *    (CONNECT/SEND/CLOSE) are blocking for the client thread. The user buffer is
+ *    used by TCP to handle retransmissions when required.in case of re
+ *    The client thread registers the command in the thread descriptor, registers itself
+ *    in the socket descriptor, unblocks the TX server thread from the BLOCKED_CLIENT 
+ *    condition, blocks itself on the BLOCKED_IO condition, and deschedules. 
+ *    When the command is completed, the TX server thread unblocks the client thread.
+ *    The TX server blocks itself on the BLOCKED_CLIENT condition, when there is no
+ *    pending commands and the R2T queue is empty. It is unblocked when a client
+ *    register a new command, or when the TX server thread register a mew request
+ *    in the R2T queue.
+ *    The tx_valid flip-flop is SET by the client thread to signal a valid command. 
+ *    It is RESET by the server thread when the command is completed: For a SEND, 
+ *    all bytes have been sent (UDP) or acknowledged (TCP).
+ *
+ * 2) For an RX transfer, it can exist only one client thread for a given socket,
+ *    but the transfer is initiated by the remote process, and the  RECV command
+ *    is not really blocking: the data can arrive before the local RECV command is
+ *    executed, and the server thread does not wait to receive all requested data
+ *    to deliver data to client thread. Therefore each socket contains a receive
+ *    buffer (rx_buf) handled as a single-writer/single-reader fifo.
+ *    The client thread consumes data from the rx_buf when possible. It blocks on the
+ *    BLOCKED_IO condition and deschedules when the rx_buf is empty.
+ *    It is unblocked by the RX server thread when new data is available in the rx_buf.
+ *    The RX server blocks itself on the BLOCKED_ISR condition When the NIC_RX packets
+ *    queue is empty. It is unblocked by the hardware when new packets are available.
+ * 
+ * Note : the socket domains and types are defined in the "shared_socket.h" file.
+ ****************************************************************************************/
+
+typedef enum udp_socket_state_e
+{
+    UDP_STATE_UNBOUND   = 0,
+    UDP_STATE_BOUND     = 1,
+    UDP_STATE_CONNECT   = 2,
+}
+udp_socket_state_t;
+
+typedef enum tcp_socket_state_e
+{
+    TCP_STATE_UNBOUND    = 10,
+    TCP_STATE_BOUND      = 11,
+    TCP_STATE_LISTEN     = 12,
+    TCP_STATE_SYN_SENT   = 13,
+    TCP_STATE_SYN_RCVD   = 14,
+    TCP_STATE_ESTAB      = 15,
+    TCP_STATE_FIN_WAIT1  = 16,
+    TCP_STATE_FIN_WAIT2  = 17,
+    TCP_STATE_CLOSING    = 18,
+    TCP_STATE_TIME_WAIT  = 19,
+    TCP_STATE_CLOSE_WAIT = 20,
+    TCP_STATE_LAST_ACK   = 21,
+}
+tcp_socket_state_t;
+
+typedef struct socket_s
+{
+    remote_busylock_t lock;          /*! lock protecting socket state                  */
+    uint32_t          domain;        /*! domain : AF_LOCAL / AF_INET                   */
+    uint32_t          type;          /*! type : SOCK_DGRAM / SOCK_STREAM               */
+    pid_t             pid;           /*! owner process identifier                      */
+    uint32_t          state;         /*! see above                                     */
+    uint32_t          local_addr;    /*! local  socket IP address                      */
+    uint32_t          remote_addr;   /*! remote socket IP address                      */
+    uint32_t          local_port;    /*! local  socket port number                     */
+    uint32_t          remote_port;   /*! remote socket port number                     */
+    uint32_t          nic_channel;   /*! derived from (remote_addr,remote_port)        */
+
+    xlist_entry_t     tx_list;       /*! sockets attached to same NIC_TX chdev         */
+    xptr_t            tx_client;     /*! extended pointer on TX client thread          */
+    sock_cmd_t        tx_cmd;        /*! command type (CONNECT/SEND/CLOSE)             */
+    uint8_t         * tx_buf;        /*! pointer on user buffer in user space          */
+    uint32_t          tx_len;        /*! number of bytes to be sent in command         */
+    uint32_t          tx_todo;       /*! number of bytes not yet sent                  */
+    uint32_t          tx_error;      /*! signal a TX command error                     */
+
+    xlist_entry_t     rx_list;       /*! sockets attached to same NIC_RX chdev         */
+    xptr_t            rx_client;     /*! extended pointer on RX client thread          */
+    remote_buf_t      rx_buf;        /*! embedded receive buffer descriptor            */
+
+    remote_buf_t      r2tq;          /*! RX_to_TX requests queue descriptor            */
+
+    remote_buf_t      crqq;          /*! connection requests queue descriptor          */         
+    /* the following fields defines the TCB used for a TCP connection                  */
+
+    uint32_t          tx_una;        /*! first unack byte in TX_data stream            */
+    uint32_t          tx_nxt;        /*! next byte to send in TX_data stream           */
+    uint32_t          tx_wnd;        /*! number of acceptable bytes in TX_data stream  */
+
+    uint32_t          rx_nxt;        /*! next expected byte in RX_data stream          */
+    uint32_t          rx_wnd;        /*! number of acceptable bytes in RX_data stream  */
+    uint32_t          rx_irs;        /*! initial sequence number in RX_data stream     */
+}
+socket_t;
+
+/****************************************************************************************
+ * This function returns a printable string for a client_to_tx_server command type.
+ ****************************************************************************************
+ * type   :  SOCKET_TX_CONNECT / SOCKET_TX_SEND / SOCKET_TX_CLOSE 
+ ***************************************************************************************/
+char * socket_cmd_str( uint32_t type );
+
+/****************************************************************************************
+ * This function returns a printable string for an UDP or TCP socket state.
+ ****************************************************************************************
+ * state  :  UDP_STATE_*** / TCP_STATE*** 
+ ***************************************************************************************/
+char * socket_state_str( uint32_t state );
+
+/****************************************************************************************
+ * This function allocates memory in the cluster defined by the <cxy> argument for a
+ * socket descriptor defined by the <domain> and <type> aruments, for the associated
+ * file descriptor, and for the various kernel buffers descriptors contained in the
+ * socket descriptor : "rx_buf" (receive buffer), "r2tq" (RX to RX requests queue), and 
+ * "crqq" (connect requests queue). It initialises the socket desccriptor static fields,
+ * (other than local_addr, local_port, remote_addr, remote_port).
+ * It registers the file descriptor in the reference process fd_array[], set the socket
+ * the socket state to UNBOUND, and returns the file identifier in the <fdid> argument.
+ ****************************************************************************************
+ * @ cxy     : [in]  target cluster identifier.
+ * @ domain  : [in]  socket protocol family (must be AF_INET).
+ * @ type    : [in]  socket type (SOCK_DGRAM / SOCK_STREAM).
+ * @ socket  : [out] buffer for a local pointer on created socket.
+ * @ fdid    : [out] buffer for file identifier.
+ * @ return 0 if success / return -1 if failure (no memory).
+ ***************************************************************************************/
+error_t socket_create( cxy_t              cxy,
+                       uint32_t           domain,
+                       uint32_t           type,
+                       struct socket_s ** socket,
+                       uint32_t         * fdid );
+                       
+/****************************************************************************************
+ * This functions releases all memory allocated to a socket identified by the <fdid>
+ * argument. This include the file descriptor, the socket descriptor, and all buffers
+ * referenced by the socket descriptor.
+ ****************************************************************************************
+ * @ fdid   : [in]  file descriptor index.
+ ***************************************************************************************/
+void socket_destroy( uint32_t fdid );
+
+/****************************************************************************************
+ * This functions registers the socket defined by the <socket_xp> argument into the
+ * lists of sockets attached to the NIC_TX and NIC_TX chdevs identified by the
+ * <nic_channel> argument.
+ ****************************************************************************************
+ * @ socket_xp   : [in]  extended pointer on socket descriptor
+ * @ nic_channel : [in]  NIC channel index.
+ ***************************************************************************************/
+void socket_link_to_servers( xptr_t    socket_xp,
+                             uint32_t  nic_channel );
+ 
+#endif	/* _SOCKET_H_ */
Index: /trunk/kernel/kern/thread.h
===================================================================
--- /trunk/kernel/kern/thread.h	(revision 656)
+++ /trunk/kernel/kern/thread.h	(revision 657)
@@ -3,5 +3,5 @@
  *
  * Author  Ghassan Almaless (2008,2009,2010,2011,2012)
- *         Alain Greiner (2016,2017,2018,2019)
+ *         Alain Greiner (2016,2017,2018,2019,2020)
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -81,17 +81,18 @@
  **************************************************************************************/
 
-#define THREAD_BLOCKED_GLOBAL    0x0001  /*! thread deactivated / wait activation     */
-#define THREAD_BLOCKED_IO        0x0002  /*! thread wait IO operation completion      */
-#define THREAD_BLOCKED_MAPPER    0x0004  /*! thread wait mapper                       */
-#define THREAD_BLOCKED_EXIT      0x0008  /*! thread blocked in join / wait exit       */
-#define THREAD_BLOCKED_JOIN      0x0010  /*! thread blocked in exit / wait join       */
-#define THREAD_BLOCKED_SEM       0x0020  /*! thread wait semaphore                    */
-#define THREAD_BLOCKED_PAGE      0x0040  /*! thread wait page access                  */
-#define THREAD_BLOCKED_IDLE      0x0080  /*! thread RPC wait RPC_FIFO non empty       */
-#define THREAD_BLOCKED_USERSYNC  0x0100  /*! thread wait (cond/mutex/barrier)         */
-#define THREAD_BLOCKED_RPC       0x0200  /*! thread wait RPC completion               */
-#define THREAD_BLOCKED_ISR       0x0400  /*! thread DEV wait ISR                      */
-#define THREAD_BLOCKED_WAIT      0x0800  /*! thread wait child process termination    */
-#define THREAD_BLOCKED_LOCK      0x1000  /*! thread wait queuelock or rwlock          */
+#define THREAD_BLOCKED_GLOBAL    0x0001  /*! ANY : deactivated / wait activation      */
+#define THREAD_BLOCKED_IO        0x0002  /*! USR : wait IO operation completion       */
+#define THREAD_BLOCKED_MAPPER    0x0004  /*! ??? : wait mapper                        */
+#define THREAD_BLOCKED_EXIT      0x0008  /*! USR : blocked in join / wait exit        */
+#define THREAD_BLOCKED_JOIN      0x0010  /*! USR : blocked in exit / wait join        */
+#define THREAD_BLOCKED_SEM       0x0020  /*! USR : wait semaphore                     */
+#define THREAD_BLOCKED_PAGE      0x0040  /*! ??? : wait page access                  */
+#define THREAD_BLOCKED_IDLE      0x0080  /*! RPC : RPC_FIFO non empty                 */
+#define THREAD_BLOCKED_USERSYNC  0x0100  /*! USR : wait cond / mutex / barrier        */
+#define THREAD_BLOCKED_RPC       0x0200  /*! ANY : RPC completion                     */
+#define THREAD_BLOCKED_ISR       0x0400  /*! DEV : wait hardware IRQ                  */
+#define THREAD_BLOCKED_WAIT      0x0800  /*! USR : wait child process termination     */
+#define THREAD_BLOCKED_LOCK      0x1000  /*! ANY : wait queuelock or rwlock           */
+#define THREAD_BLOCKED_CLIENT    0x2000  /*! DEV : client threads queue non empty     */
 
 /***************************************************************************************
@@ -190,4 +191,5 @@
     list_entry_t        wait_list;       /*! member of a local waiting queue          */
     xlist_entry_t       wait_xlist;      /*! member of a trans-cluster waiting queue  */
+    xlist_entry_t       tmp_xlist;       /*! member of a trans-cluster kleenex queue  */
 
 	uint32_t            busylocks;	     /*! number of taken busylocks                */
Index: /trunk/kernel/kernel_config.h
===================================================================
--- /trunk/kernel/kernel_config.h	(revision 656)
+++ /trunk/kernel/kernel_config.h	(revision 657)
@@ -61,5 +61,5 @@
 #define DEBUG_DEV_PIC                     0
 
-#define DEBUG_DEVFS_GLOBAL_INIT           0
+#define DEBUG_DEVFS_GLOBAL_INIT           0 
 #define DEBUG_DEVFS_LOCAL_INIT            0
 #define DEBUG_DEVFS_MOVE                  0
@@ -121,4 +121,5 @@
 
 #define DEBUG_MAPPER_GET_PAGE             0
+#define DEBUG_MAPPER_GET_FAT_PAGE         0
 #define DEBUG_MAPPER_HANDLE_MISS          0
 #define DEBUG_MAPPER_MOVE_KERNEL          0
@@ -152,22 +153,15 @@
 #define DEBUG_RPC_SERVER_GENERIC          0
 
-#define DEBUG_RPC_MAPPER_MOVE_USER        0
+#define DEBUG_RPC_FBF_DISPLAY             0
 #define DEBUG_RPC_PROCESS_MAKE_FORK       0
 #define DEBUG_RPC_PROCESS_SIGACTION       0
 #define DEBUG_RPC_THREAD_USER_CREATE      0
 #define DEBUG_RPC_THREAD_KERNEL_CREATE    0
-#define DEBUG_RPC_VFS_DENTRY_CREATE       0
-#define DEBUG_RPC_VFS_DENTRY_DESTROY      0
-#define DEBUG_RPC_VFS_DEVICE_GET_DENTRY   0
-#define DEBUG_RPC_VFS_FILE_CREATE         0
-#define DEBUG_RPC_VFS_FILE_DESTROY        0
-#define DEBUG_RPC_VFS_FS_NEW_DENTRY       0
-#define DEBUG_RPC_VFS_FS_ADD_DENTRY       0
-#define DEBUG_RPC_VFS_INODE_CREATE        0
-#define DEBUG_RPC_VFS_INODE_DESTROY       0
+#define DEBUG_RPC_USER_DIR_CREATE         0
+#define DEBUG_RPC_USER_DIR_DESTROY        0
 #define DEBUG_RPC_VMM_CREATE_VSEG         0
-#define DEBUG_RPC_VMM_GET_PTE             0
-#define DEBUG_RPC_VMM_GET_VSEG            0
-#define DEBUG_RPC_VMM_DELETE_VSEG         0
+#define DEBUG_RPC_VMM_RESIZE_VSEG         0
+#define DEBUG_RPC_VMM_REMOVE_VSEG         0
+#define DEBUG_RPC_VMM_SET_COW             0
 
 #define DEBUG_RWLOCK_TYPE                 0        // lock type 0 is undefined => no debug
@@ -246,5 +240,5 @@
 #define DEBUG_VFS_FILE_CREATE             0
 #define DEBUG_VFS_GET_PATH                0
-#define DEBUG_VFS_INODE_CREATE            0 
+#define DEBUG_VFS_INODE_CREATE            0
 #define DEBUG_VFS_INODE_LOAD_ALL          0
 #define DEBUG_VFS_KERNEL_MOVE             0
@@ -290,12 +284,12 @@
 #define LOCK_VMM_STACK         3   // local  (B)  protect VMM stack vseg allocator   
 #define LOCK_VMM_MMAP          4   // local  (B)  protect VMM mmap vseg allocator
-#define LOCK_VFS_CTX           5   // local  (B)  protect vfs context state
-#define LOCK_KCM_STATE         6   // local  (B)  protect KCM allocator state
-#define LOCK_KHM_STATE         7   // local  (B)  protect KHM allocator state
-#define LOCK_HTAB_STATE        8   // local  (B)  protect a local htab state
-
+#define LOCK_KCM_STATE         5   // local  (B)  protect KCM allocator state
+#define LOCK_KHM_STATE         6   // local  (B)  protect KHM allocator state
+#define LOCK_HTAB_STATE        7   // local  (B)  protect a local htab state
+
+#define LOCK_VFS_CTX           8   // remote (B)  protect vfs context state
 #define LOCK_PPM_FREE          9   // remote (B)  protect PPM allocator free_pages lists
 #define LOCK_THREAD_JOIN      10   // remote (B)  protect join/exit between two threads
-#define LOCK_XHTAB_STATE      11   // remote (B)  protect  a distributed xhtab state
+#define LOCK_XHTAB_STATE      11   // remote (B)  protect a distributed xhtab state
 #define LOCK_CHDEV_QUEUE      12   // remote (B)  protect chdev threads waiting queue
 #define LOCK_CHDEV_TXT0       13   // remote (B)  protect access to kernel terminal TXT0
@@ -325,5 +319,6 @@
 #define LOCK_VFS_FILE         33   // remote (RW) protect file descriptor state
 #define LOCK_VFS_MAIN         34   // remote (RW) protect vfs traversal (in root inode)
-#define LOCK_FATFS_FAT        35   // remote (RW) protect exclusive access to the FATFS FAT
+#define LOCK_FATFS_FAT        35   // remote (RW) protect exclusive access to the VFS FAT
+#define LOCK_FBF_WINDOWS      36   // remote (RW) protect FBF windows set
 
 ////////////////////////////////////////////////////////////////////////////////////////////
@@ -383,4 +378,6 @@
 ////////////////////////////////////////////////////////////////////////////////////////////
 
+#define CONFIG_VFS_ROOT_CXY                 0          // VFS_ROOT and FAT mapper cluster
+
 #define CONFIG_VFS_MAX_INODES               128        // max number of inodes per cluster
 #define CONFIG_VFS_MAX_NAME_LENGTH          56         // dentry name max length (bytes)
@@ -397,9 +394,16 @@
 
 ////////////////////////////////////////////////////////////////////////////////////////////
+//                              FBF WINDOWS       
+////////////////////////////////////////////////////////////////////////////////////////////
+
+#define CONFIG_FBF_WINDOWS_MAX_NR           64         // max number of windows
+#define CONFIG_FBF_WINDOWS_MAX_WIDTH        1024       // max number of pixels in FBF line
+#define CONFIG_FBF_WINDOWS_MAX_HEIGHT       1024       // max number of lines in FBF
+
+////////////////////////////////////////////////////////////////////////////////////////////
 //                                  DQDT        
 ////////////////////////////////////////////////////////////////////////////////////////////
 
 #define CONFIG_DQDT_LEVELS_NR               5
-#define CONFIG_DQDT_TICKS_PER_QUANTUM       1        // number of ticks between updates
 
 ////////////////////////////////////////////////////////////////////////////////////////////
@@ -414,8 +418,8 @@
 ////////////////////////////////////////////////////////////////////////////////////////////
 
-#define CONFIG_SCHED_TICK_MS_PERIOD         10000   // number of milliseconds per period
-#define CONFIG_SCHED_TICKS_PER_QUANTUM      1       // number of ticks between scheduling
-#define CONFIG_SCHED_MAX_THREADS_NR         32      // max number of threads per core
-#define CONFIG_SCHED_IDLE_MODE_SLEEP        0       // idle thread use sleep mode if non 0
+#define CONFIG_SCHED_TICK_MS_PERIOD         10000    // number of milliseconds per period
+#define CONFIG_SCHED_TICKS_PER_QUANTUM      1        // number of ticks between scheduling
+#define CONFIG_SCHED_MAX_THREADS_NR         32       // max number of threads per core
+#define CONFIG_SCHED_IDLE_MODE_SLEEP        0        // idle thread use sleep mode if non 0
 
 ////////////////////////////////////////////////////////////////////////////////////////////
@@ -423,7 +427,7 @@
 ////////////////////////////////////////////////////////////////////////////////////////////
 
-#define CONFIG_THREADS_MAX_PER_CLUSTER      32      // max threads per cluster per process
-#define CONFIG_THREAD_DESC_SIZE             0x4000  // thread desc size (with kernel stack)
-#define CONFIG_THREAD_DESC_ORDER            2       // ln( number of 4K pages )
+#define CONFIG_THREADS_MAX_PER_CLUSTER      32       // max threads per cluster per process
+#define CONFIG_THREAD_DESC_SIZE             0x4000   // thread desc size (with kernel stack)
+#define CONFIG_THREAD_DESC_ORDER            2        // ln( number of 4K pages )
 
 ////////////////////////////////////////////////////////////////////////////////////////////
@@ -433,5 +437,5 @@
 #define CONFIG_REMOTE_FIFO_SLOTS		    16
 #define CONFIG_REMOTE_FIFO_MAX_ITERATIONS   1024
-#define CONFIG_RPC_THREADS_MAX              4      // max number of RPC threads per core
+#define CONFIG_RPC_THREADS_MAX              4       // max number of RPC threads per core
 
 ////////////////////////////////////////////////////////////////////////////////////////////
@@ -439,14 +443,14 @@
 ////////////////////////////////////////////////////////////////////////////////////////////
 
-#define CONFIG_VMM_VSPACE_SIZE        0x100000     // virtual space          : 4   Gbytes
-
-#define CONFIG_VMM_UTILS_BASE         0x000200     // UTILS zone base        : 2   Mbytes
-#define CONFIG_VMM_ELF_BASE           0x000400     // ELF zone base          : 4   Mbytes
-#define CONFIG_VMM_HEAP_BASE          0x040000     // HEAP zone base         : 32  Mbytes
-#define CONFIG_VMM_STACK_BASE         0x0C0000     // STACK zone base        : 3   Gbytes
-
-#define CONFIG_VMM_ARGS_SIZE          0x000004     // args vseg size         : 16  Kbytes
-#define CONFIG_VMM_ENVS_SIZE          0x000008     // envs vseg size         : 32  Kbytes
-#define CONFIG_VMM_STACK_SIZE         0x001000     // single stack vseg size : 16  Mbytes
+#define CONFIG_VMM_VSPACE_SIZE        0x100000      // virtual space          : 4   Gbytes
+
+#define CONFIG_VMM_UTILS_BASE         0x000200      // UTILS zone base        : 2   Mbytes
+#define CONFIG_VMM_ELF_BASE           0x000400      // ELF zone base          : 4   Mbytes
+#define CONFIG_VMM_HEAP_BASE          0x040000      // HEAP zone base         : 32  Mbytes
+#define CONFIG_VMM_STACK_BASE         0x0C0000      // STACK zone base        : 3   Gbytes
+ 
+#define CONFIG_VMM_ARGS_SIZE          0x000004      // args vseg size         : 16  Kbytes
+#define CONFIG_VMM_ENVS_SIZE          0x000008      // envs vseg size         : 32  Kbytes
+#define CONFIG_VMM_STACK_SIZE         0x001000      // single stack vseg size : 16  Mbytes
 
 #define CONFIG_VMM_HEAP_MAX_ORDER     18           // max size of MMAP vseg  :  1  Gbytes
@@ -455,10 +459,10 @@
 ////////////////////////////////////////////////////////////////////////////////////////////
 
-#define CONFIG_PPM_PAGE_SIZE          4096         // physical page size (bytes)
-#define CONFIG_PPM_PAGE_SHIFT         12           // physical page shift (bits)
-#define CONFIG_PPM_PAGE_MASK          0x00000FFF   // physical page mask     
-#define CONFIG_PPM_MAX_ORDER          16           // ln(total number of pages per cluster)
-#define CONFIG_PPM_HEAP_ORDER         10           // ln(number of heap pages per cluster)
-#define CONFIG_PPM_MAX_RSVD           32           // max reserved zones on the machine
+#define CONFIG_PPM_PAGE_SIZE          4096          // physical page size (bytes)
+#define CONFIG_PPM_PAGE_SHIFT         12            // physical page shift (bits)
+#define CONFIG_PPM_PAGE_MASK          0x00000FFF    // physical page mask     
+#define CONFIG_PPM_MAX_ORDER          16            // ln(total number of pages per cluster)
+#define CONFIG_PPM_HEAP_ORDER         10            // ln(number of heap pages per cluster)
+#define CONFIG_PPM_MAX_RSVD           32            // max reserved zones on the machine
 
 #define CONFIG_PPM_PAGE_ALIGNED       __attribute__((aligned(CONFIG_PPM_PAGE_SIZE)))
@@ -470,5 +474,6 @@
 #define CONFIG_INSTRUMENTATION_SYSCALLS    0
 #define CONFIG_INSTRUMENTATION_PGFAULTS    0
-#define CONFIG_INSTRUMENTATION_FOOTPRINT   0
+#define CONFIG_INSTRUMENTATION_FOOTPRINT   1
+#define CONFIG_INSTRUMENTATION_CHDEVS      0
 #define CONFIG_INSTRUMENTATION_GPT         0
 
